#include <windows.h>
#include <stdio.h>
#include "..\Setting\CSetting.h"
#include "ThreadSnapShot.h"
#include "..\ijpeglib\BmpToJpg.h"

extern BOOL RGB32toRGB24(BITMAPINFOHEADER *pbIn,BITMAPINFOHEADER *pbOut);

unsigned int __stdcall ThreadSnapShot(LPVOID pPalam){
	ST_THREAD_SNAPSHOT *pInfo = (ST_THREAD_SNAPSHOT *)pPalam;
	BITMAPFILEHEADER bfh;
	BITMAPINFOHEADER *pbmi;
	
	FILE *fp;
	BOOL lRet = FALSE;
	
	if(pInfo == NULL)return 0;

	pbmi = (BITMAPINFOHEADER *)pInfo->m_plDIB;
	
	switch(pInfo->m_nType){
	case PTDIGI_SNAP_FMT_BMP:
		{
			fp = fopen(pInfo->m_szFileName,"wb");
			if(fp != NULL){
				
				//rbg}bvt@Cwb_
				ZeroMemory(&bfh, sizeof(BITMAPFILEHEADER));
				bfh.bfType = 'MB';
				bfh.bfSize = sizeof( bfh ) + (pbmi->biHeight * pbmi->biWidth * (pbmi->biBitCount/8)) + sizeof( BITMAPINFOHEADER );
				bfh.bfOffBits = sizeof( BITMAPINFOHEADER ) + sizeof( BITMAPFILEHEADER );
					
				fwrite(&bfh,sizeof(bfh),1,fp);
				fwrite(pInfo->m_plDIB,pInfo->m_lBufSize,1,fp);

				fclose(fp);

				lRet = TRUE;
			}
		}
		break;
	case PTDIGI_SNAP_FMT_JPG:
		{

			BITMAPINFOHEADER *pbmi24;
			
			fp = fopen(pInfo->m_szFileName,"wb");
			
			if(pbmi->biBitCount == 32){
				pbmi24 = (BITMAPINFOHEADER *)new  char[sizeof( BITMAPINFOHEADER ) + pbmi->biHeight * pbmi->biWidth * 3];
				RGB32toRGB24(pbmi,pbmi24);

				delete [] pbmi;
				pbmi = pbmi24;
				pInfo->m_plDIB = (long *)pbmi;
			}

			if(pbmi->biBitCount == 24){
				if(fp != NULL){
					BmpToJpegSaveFile(fp, pbmi, pInfo->m_nQuality, 0);
					fclose(fp);
					lRet = TRUE;
				}
			}

			//delete [] pbmi;
		}
		break;
	}

	//mۂobt@폜
	delete [] pInfo->m_plDIB;
	delete pInfo;

	return 0;
}